//
// StringFormatter.h
//
// $Id: //poco/Main/WebWidgets/include/Poco/WebWidgets/StringFormatter.h#1 $
//
// Library: WebWidgets
// Package: Formatters
// Module:  StringFormatter
//
// Definition of the StringFormatter class.
//
// Copyright (c) 2008, Applied Informatics Software Engineering GmbH.
// and Contributors.
//
// Permission is hereby granted, free of charge, to any person or organization
// obtaining a copy of the software and accompanying documentation covered by
// this license (the "Software") to use, reproduce, display, distribute,
// execute, and transmit the Software, and to prepare derivative works of the
// Software, and to permit third-parties to whom the Software is furnished to
// do so, all subject to the following:
// 
// The copyright notices in the Software and this entire statement, including
// the above license grant, this restriction and the following disclaimer,
// must be included in all copies of the Software, in whole or in part, and
// all derivative works of the Software, unless such copies or derivative
// works are solely in the form of machine-executable object code generated by
// a source language processor.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
// FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
//


#ifndef WebWidgets_StringFormatter_INCLUDED
#define WebWidgets_StringFormatter_INCLUDED


#include "Poco/WebWidgets/Formatter.h"


namespace Poco {
namespace WebWidgets {


class WebWidgets_API StringFormatter: public Formatter
	/// A simple formatter for string values.
{
public:
	typedef Poco::AutoPtr<StringFormatter> Ptr;
	
	StringFormatter();
	std::string format(const Poco::Any& value) const;		
	Poco::Any parse(const std::string& value) const;
	
	bool lowerThan(const Poco::Any& first, const Poco::Any& second) const;

protected:
	~StringFormatter();
	
private:
	int _precision;
};


} } // namespace Poco::WebWidgets


#endif // WebWidgets_StringFormatter_INCLUDED
